Imports Telerik.WinControls.UI
Imports System.ComponentModel

Public Class MyComboBoxEditor
    Inherits RadDropDownListEditor
    Protected Overrides Function CreateEditorElement() As Telerik.WinControls.RadElement
        Return New MyComboBoxEditorElement()
    End Function
End Class

Public Class MyComboBoxEditorElement
    Inherits RadDropDownListEditorElement
    Protected Overrides Sub OnLoaded()
        MyBase.OnLoaded()
        AddHandler Me.ListElement.CreatingVisualItem, AddressOf ListElement_CreatingVisualItem
    End Sub

    Private Sub ListElement_CreatingVisualItem(ByVal sender As Object, ByVal args As CreatingVisualListItemEventArgs)
        'add button element
        Dim visualItem As RadListVisualItem = New RadListVisualItem()
        visualItem.Padding = New Padding(12, 0, 0, 0)

        Dim button As RadButtonElement = New RadButtonElement()
        button.MinSize = New System.Drawing.Size(12, 12)
        button.Text = "x"
        button.MaxSize = button.MinSize
        button.TextAlignment = System.Drawing.ContentAlignment.MiddleLeft
        AddHandler button.Click, AddressOf button_Click

        visualItem.Children.Add(button)
        args.VisualItem = visualItem
    End Sub

    Private Sub button_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Remove the item from the DataSource collection
        Dim item As RadListVisualItem = CType((CType(sender, RadButtonElement)).Parent, RadListVisualItem)
        CType(Me.DataSource, BindingList(Of String)).Remove(item.Data.ToString())
        Me.SelectedIndex = -1
    End Sub

    Protected Overrides Sub ProcessKeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        If e.KeyCode = Keys.Enter Then
            Dim stringsDataSource As BindingList(Of String) = CType(Me.DataSource, BindingList(Of String))
            Dim currentText As String = Me.Text

            If (Not ExistsInDataSource(currentText, stringsDataSource)) Then
                stringsDataSource.Add(Me.Text)
                Me.SelectedIndex = Me.Items.Count - 1
                Return
            End If
        End If
        MyBase.ProcessKeyDown(sender, e)
    End Sub

    Private Function ExistsInDataSource(ByVal currentText As String, ByVal dataSource As BindingList(Of String)) As Boolean
        Dim i As Integer = 0
        Do While i < dataSource.Count
            If currentText = dataSource(i) Then
                Return True
            End If
            i += 1
        Loop

        Return False
    End Function
End Class
